=== debian/changelog ===
pagmo (2.18.0-2) unstable; urgency=medium

  * Adding -latomic flag to build tests on armel and mipsel
  * Adding a patch to test the equality of double numbers by checking that
    their difference is small
  * Marking the shared lib package as Multi-Arch: same

 -- Pierre Gruet <pgt@debian.org>  Fri, 10 Jun 2022 16:26:02 +0200

pagmo (2.18.0-1) unstable; urgency=medium

  * Initial release (Closes: #1011557)

 -- Pierre Gruet <pgt@debian.org>  Fri, 27 May 2022 22:35:09 +0200
