=== debian/rules ===
#!/usr/bin/make -f

export DEB_BUILD_MAINT_OPTIONS = hardening=+all
include /usr/share/dpkg/buildflags.mk
CFLAGS+=$(CPPFLAGS)
CXXFLAGS+=$(CPPFLAGS)
DPKG_EXPORT_BUILDFLAGS = 1
DEB_HOST_MULTIARCH ?= $(shell dpkg-architecture -qDEB_HOST_MULTIARCH)

CONFIG_SHARED_PATH  = config_shared
CONFIG_STATIC_PATH  = config_static

# Only building tests if we want to run them
ifeq (,$(filter nocheck,$(DEB_BUILD_OPTIONS)))
	build_tests := -DPAGMO_BUILD_TESTS=ON
else
	build_tests := -DPAGMO_BUILD_TESTS=OFF
endif

%:
	dh $@ --buildsystem=cmake

override_dh_auto_configure:
	dh_auto_configure  -B$(CONFIG_SHARED_PATH) -- \
	    -DPAGMO_BUILD_STATIC_LIBRARY=OFF \
	    $(build_tests) \
            -DCMAKE_INSTALL_PREFIX:PATH=/usr \
            -DCMAKE_INSTALL_LIBDIR:PATH="/usr/lib/$(DEB_HOST_MULTIARCH)" \
            -DPAGMO_WITH_EIGEN3=ON \
            -DINSTALL_DESTDIR:PATH=$(CURDIR)/debian/tmp
	dh_auto_configure  -B$(CONFIG_STATIC_PATH) -- \
	    -DPAGMO_BUILD_STATIC_LIBRARY=ON \
            -DCMAKE_INSTALL_PREFIX:PATH=/usr \
            -DCMAKE_INSTALL_LIBDIR:PATH="/usr/lib/$(DEB_HOST_MULTIARCH)" \
            -DPAGMO_WITH_EIGEN3=ON \
            -DINSTALL_DESTDIR:PATH=$(CURDIR)/debian/tmp

override_dh_auto_build:
	dh_auto_build -B$(CONFIG_STATIC_PATH)
	dh_auto_build -B$(CONFIG_SHARED_PATH)

override_dh_auto_test:
ifeq (,$(filter nocheck,$(DEB_BUILD_OPTIONS)))
	dh_auto_test -B$(CONFIG_SHARED_PATH)
endif

override_dh_auto_clean:
	dh_auto_clean
	rm -rf $(CONFIG_SHARED_PATH) $(CONFIG_STATIC_PATH)

override_dh_auto_install:
	dh_auto_install -B$(CONFIG_STATIC_PATH)
	dh_auto_install -B$(CONFIG_SHARED_PATH)
