## pagmo 2.19.0

=== CMakeLists.txt ===
--- 
+++ 
@@ -13,7 +13,7 @@
     FORCE)
 endif()
 
-project(pagmo VERSION 2.18.0 LANGUAGES CXX C)
+project(pagmo VERSION 2.19.0 LANGUAGES CXX C)
 
 # Setup module path.
 list(APPEND CMAKE_MODULE_PATH "${CMAKE_CURRENT_SOURCE_DIR}/cmake_modules" "${CMAKE_CURRENT_SOURCE_DIR}/cmake_modules/yacma")
@@ -62,12 +62,24 @@
     set(PAGMO_WITH_FORK_ISLAND NO)
 endif()
 
+# Threading setup.
+# NOTE: do it before checking for the presence of pthread_atfork(),
+# since we need to know if we are using pthreads.
+include(YACMAThreadingSetup)
+
+# If the fork() system call is supported and we are using pthreads,
+# check if the pthread_atfork() function is available. This is used
+# to clean up problematic global variables (such as the task queue
+# cache) when a process is forked.
+if(PAGMO_HAVE_FORK_SYSCALL AND CMAKE_USE_PTHREADS_INIT)
+    set(CMAKE_REQUIRED_LIBRARIES "${CMAKE_THREAD_LIBS_INIT}")
+    CHECK_CXX_SYMBOL_EXISTS(pthread_atfork "pthread.h" PAGMO_HAVE_PTHREAD_ATFORK)
+    unset(CMAKE_REQUIRED_LIBRARIES)
+endif()
+
 # Initial setup of compiler flags.
 include(YACMACompilerLinkerSettings)
 include(CheckCXXCompilerFlag)
-
-# Threading setup.
-include(YACMAThreadingSetup)
 
 # NOTE: on Unix systems, the correct library installation path
 # could be something other than just "lib", such as "lib64",
@@ -194,7 +206,7 @@
     "${CMAKE_CURRENT_SOURCE_DIR}/src/problems/cec2009.cpp"
     "${CMAKE_CURRENT_SOURCE_DIR}/src/problems/schwefel.cpp"
     "${CMAKE_CURRENT_SOURCE_DIR}/src/problems/rosenbrock.cpp"
-    "${CMAKE_CURRENT_SOURCE_DIR}/src/problems/hock_schittkowsky_71.cpp"
+    "${CMAKE_CURRENT_SOURCE_DIR}/src/problems/hock_schittkowski_71.cpp"
     "${CMAKE_CURRENT_SOURCE_DIR}/src/problems/inventory.cpp"
     "${CMAKE_CURRENT_SOURCE_DIR}/src/problems/zdt.cpp"
     "${CMAKE_CURRENT_SOURCE_DIR}/src/problems/dtlz.cpp"
@@ -229,6 +241,7 @@
     "${CMAKE_CURRENT_SOURCE_DIR}/src/algorithms/sga.cpp"
     "${CMAKE_CURRENT_SOURCE_DIR}/src/algorithms/simulated_annealing.cpp"
     "${CMAKE_CURRENT_SOURCE_DIR}/src/algorithms/moead.cpp"
+    "${CMAKE_CURRENT_SOURCE_DIR}/src/algorithms/moead_gen.cpp"
     "${CMAKE_CURRENT_SOURCE_DIR}/src/algorithms/nsga2.cpp"
     "${CMAKE_CURRENT_SOURCE_DIR}/src/algorithms/gaco.cpp"
     "${CMAKE_CURRENT_SOURCE_DIR}/src/algorithms/de1220.cpp"
@@ -254,14 +267,3 @@
     # Utils.
     "${CMAKE_CURRENT_SOURCE_DIR}/src/utils/constrained.cpp"
     "${CMAKE_CURRENT_SOURCE_DIR}/src/utils/discrepancy.cpp"
-    "${CMAKE_CURRENT_SOURCE_DIR}/src/utils/generic.cpp"
-    "${CMAKE_CURRENT_SOURCE_DIR}/src/utils/genetic_operators.cpp"
-    "${CMAKE_CURRENT_SOURCE_DIR}/src/utils/multi_objective.cpp"
-    "${CMAKE_CURRENT_SOURCE_DIR}/src/utils/hypervolume.cpp"
-    "${CMAKE_CURRENT_SOURCE_DIR}/src/utils/hv_algos/hv_algorithm.cpp"
-    "${CMAKE_CURRENT_SOURCE_DIR}/src/utils/hv_algos/hv_bf_approx.cpp"
-    "${CMAKE_CURRENT_SOURCE_DIR}/src/utils/hv_algos/hv_bf_fpras.cpp"
-    "${CMAKE_CURRENT_SOURCE_DIR}/src/utils/hv_algos/hv_hv2d.cpp"
-    "${CMAKE_CURRENT_SOURCE_DIR}/src/utils/hv_algos/hv_hv3d.cpp"
-    "${CMAKE_CURRENT_SOURCE_DIR}/src/utils/hv_algos/hv_hvwfg.cpp"
-    # Detail.
