=== tests/CMakeLists.txt ===
--- 
+++ 
@@ -59,7 +59,7 @@
 ADD_PAGMO_TESTCASE(gradients_and_hessians)
 ADD_PAGMO_TESTCASE(griewank)
 ADD_PAGMO_TESTCASE(hypervolume)
-ADD_PAGMO_TESTCASE(hock_schittkowsky_71)
+ADD_PAGMO_TESTCASE(hock_schittkowski_71)
 ADD_PAGMO_TESTCASE(inventory)
 ADD_PAGMO_TESTCASE(lennard_jones)
 ADD_PAGMO_TESTCASE(migration_torture_test)
@@ -73,6 +73,7 @@
 ADD_PAGMO_TESTCASE(mbh)
 ADD_PAGMO_TESTCASE(member_bfe)
 ADD_PAGMO_TESTCASE(moead)
+ADD_PAGMO_TESTCASE(moead_gen)
 ADD_PAGMO_TESTCASE(multi_objective)
 ADD_PAGMO_TESTCASE(nsga2)
 ADD_PAGMO_TESTCASE(nspso)
