=== debian/changelog ===
pagmo (2.19.0-3.1build1) noble; urgency=medium

  * No-change rebuild for CVE-2024-3094

 -- William Grant <wgrant@ubuntu.com>  Mon, 01 Apr 2024 16:13:12 +1100

pagmo (2.19.0-3.1) unstable; urgency=medium

  * Non-maintainer upload.
  * Rename libraries for 64-bit time_t transition.  Closes: #1063200

 -- Benjamin Drung <bdrung@debian.org>  Thu, 29 Feb 2024 19:16:42 +0000

pagmo (2.19.0-3) unstable; urgency=medium

  * Fixing the clean target (Closes: #1048278)

  [ Adrian Bunk ]
  * Build with -ffloat-store to avoid excess precision on i386

 -- Pierre Gruet <pgt@debian.org>  Wed, 25 Oct 2023 16:49:17 +0200

pagmo (2.19.0-2) unstable; urgency=medium

  * Upload to unstable, transition starts

 -- Pierre Gruet <pgt@debian.org>  Thu, 27 Jul 2023 06:52:25 +0200

pagmo (2.19.0-1) experimental; urgency=medium

  * New upstream version 2.19.0
  * Refreshing patches
  * Bumping SOVERSION from 8 to 9
  * Raising Standards version to 4.6.2 (no change)

  [ Debian Janitor ]
  * Apply multi-arch hints. + libpagmo-dev: Add Multi-Arch: same.

 -- Pierre Gruet <pgt@debian.org>  Fri, 23 Jun 2023 10:26:38 +0200
