=== debian/control ===
--- 
+++ 
@@ -1,22 +1,26 @@
 Source: pagmo
 Section: science
 Priority: optional
-Maintainer: Debian Science Maintainers <debian-science-maintainers@lists.alioth.debian.org>
+Maintainer: Ubuntu Developers <ubuntu-devel-discuss@lists.ubuntu.com>
+XSBC-Original-Maintainer: Debian Science Maintainers <debian-science-maintainers@lists.alioth.debian.org>
 Uploaders: Julien Schueller <schueller@phimeca.com>,
            Pierre Gruet <pgt@debian.org>
-Build-Depends: debhelper-compat (= 13),
+Build-Depends: dpkg-dev (>= 1.22.5), debhelper-compat (= 13),
                cmake,
                libeigen3-dev,
                libboost-serialization-dev,
                libboost-test-dev <!nocheck>,
                libtbb-dev
-Standards-Version: 4.6.1
+Standards-Version: 4.6.2
 Homepage: https://github.com/esa/pagmo2
 Vcs-Browser: https://salsa.debian.org/science-team/pagmo
 Vcs-Git: https://salsa.debian.org/science-team/pagmo.git
 Rules-Requires-Root: no
 
-Package: libpagmo8
+Package: libpagmo9t64
+Provides: ${t64:Provides}
+Replaces: libpagmo9
+Breaks: libpagmo9 (<< ${source:Version})
 Section: libs
 Architecture: any
 Depends: ${shlibs:Depends},
@@ -33,10 +37,11 @@
 Section: libdevel
 Architecture: any
 Depends: ${misc:Depends},
-         libpagmo8 (= ${binary:Version}),
+         libpagmo9t64 (= ${binary:Version}),
          libeigen3-dev,
          libboost-serialization-dev,
          libtbb-dev
+Multi-Arch: same
 Description: library for massively parallel optimisation (development files)
  pagmo is a C++ scientific library built around the idea of providing an
  unified interface to optimization algorithms and to optimization
