## pagmo 2.19.1

=== CMakeLists.txt ===
--- 
+++ 
@@ -13,7 +13,7 @@
     FORCE)
 endif()
 
-project(pagmo VERSION 2.19.0 LANGUAGES CXX C)
+project(pagmo VERSION 2.19.1 LANGUAGES CXX C)
 
 # Setup module path.
 list(APPEND CMAKE_MODULE_PATH "${CMAKE_CURRENT_SOURCE_DIR}/cmake_modules" "${CMAKE_CURRENT_SOURCE_DIR}/cmake_modules/yacma")
