=== debian/changelog ===
pagmo (2.19.1-1) unstable; urgency=medium

  * New upstream version 2.19.1
  * Refreshing patches
  * Raising Standards version to 4.7.0 (no change)

 -- Pierre Gruet <pgt@debian.org>  Sun, 06 Oct 2024 22:44:05 +0200
