=== debian/control ===
--- 
+++ 
@@ -1,8 +1,7 @@
 Source: pagmo
 Section: science
 Priority: optional
-Maintainer: Ubuntu Developers <ubuntu-devel-discuss@lists.ubuntu.com>
-XSBC-Original-Maintainer: Debian Science Maintainers <debian-science-maintainers@lists.alioth.debian.org>
+Maintainer: Debian Science Maintainers <debian-science-maintainers@lists.alioth.debian.org>
 Uploaders: Julien Schueller <schueller@phimeca.com>,
            Pierre Gruet <pgt@debian.org>
 Build-Depends: dpkg-dev (>= 1.22.5), debhelper-compat (= 13),
@@ -11,7 +10,7 @@
                libboost-serialization-dev,
                libboost-test-dev <!nocheck>,
                libtbb-dev
-Standards-Version: 4.6.2
+Standards-Version: 4.7.0
 Homepage: https://github.com/esa/pagmo2
 Vcs-Browser: https://salsa.debian.org/science-team/pagmo
 Vcs-Git: https://salsa.debian.org/science-team/pagmo.git
